



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>python之MRO和C3算法</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">python之MRO和C3算法</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 04:50:53 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>python2类和python3类的区别<br />pyhon2中才分新式类与经典类,python3中统一都是新式类<br />Python 2.x中默认都是经典类,只有显式继承了object才是新式类<br />python 3.x中默认都是新式类,经典类被移除,不必显式的继承object<br />改变了经典类中一个多继承的bug,因为其采用了广度优先的算法</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1169701/201812/1169701-20181224171325226-875792563.png" /></p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums"> 1 class A(object):<br />
 2     def test(self):<br />
 3         print('from A')<br />
 4<br />
 5 class B(A):<br />
 6     def test(self):<br />
 7         print('from B')<br />
 8<br />
 9 class C(A):<br />
10     def test(self):<br />
11         print('from C')<br />
12<br />
13 class D(B):<br />
14     def test(self):<br />
15         print('from D')<br />
16<br />
17 class E(C):<br />
18     def test(self):<br />
19         print('from E')<br />
20<br />
21 class F(D,E):<br />
22     # def test(self):<br />
23     #     print('from F')<br />
24     pass<br />
25 f1=F()<br />
26 f1.test()<br />
27 print(F.__mro__) #只有新式才有这个属性可以查看线性列表,经典类没有这个属性<br />
28 #新式类继承顺序:F-&gt;D-&gt;B-&gt;E-&gt;C-&gt;A<br />
29 #经典类继承顺序:F-&gt;D-&gt;B-&gt;A-&gt;E-&gt;C</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>MRO: method resolution order 方法的查找顺序<br />经典类的MRO 树形结构的深度优先遍历 --&gt; 树形结构遍历</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1169701/201812/1169701-20181224170747978-1958938662.png" /></p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums"> 1 class A:<br />
 2     pass<br />
 3 class B(A):<br />
 4     pass<br />
 5 class C(A):<br />
 6     pass<br />
 7 class D(B, C):<br />
 8     pass<br />
 9 class E:<br />
10     pass<br />
11 class F(D, E):<br />
12     pass<br />
13 class G(F, D):<br />
14     pass<br />
15 class I:<br />
16     pass<br />
17 class J(B, C):<br />
18     pass<br />
19 class K(A):<br />
20     pass<br />
21 class H(I, J, K):<br />
22     pass<br />
23 class Foo(H, G):<br />
24     pass<br />
25 print(Foo.__mro__)<br />
26 结果<br />
27 Foo --&gt;H--&gt;I--&gt;J--&gt;G--&gt;F--&gt;D--&gt;B--&gt;C--&gt;K--&gt;A--&gt;E--&gt;'object'</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>新式类的MRO C3算法<br />1. 拆分<br />2. 合并</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums"> 1 class A:<br />
 2     pass<br />
 3 class B(A):<br />
 4     pass<br />
 5 class C(A):<br />
 6     pass<br />
 7 class D(B, C):<br />
 8     pass<br />
 9 class E(C, A):<br />
10     pass<br />
11 class F(D, E):<br />
12     pass<br />
13 class M:<br />
14     pass<br />
15 class N(M):<br />
16     pass<br />
17 class P(E, A):<br />
18     pass<br />
19 class X:<br />
20     pass<br />
21 class Q(P,N,X):<br />
22     pass<br />
23 class G(Q, F):<br />
24     pass<br />
25 class H(G, F):<br />
26     pass<br />
27<br />
28<br />
29 加法:merge(),拿第一项的第一位和后面项除了第一位的每位比较,如果没有出现,则该位元素算出<br />
30 如果出现了,此时开始下一项的第一位继续和后面项除了第一位的每一位比较,<br />
31 如果后边项里除了第一位的其他位出现有,则继续开始拿下一项的第一位和后一项除了第一位的其他位做比较<br />
32 如果后边项没有出现,取完这一项的第一位后,重新返回第一项继续执行判断第一项的第一位与后边项除了第一位比较<br />
33<br />
34 比如<br />
35 F + DBCA + ECA + DE<br />
36 DBCA + ECA + DE<br />
37 BCA + ECA + E<br />
38 CA + CA<br />
39 A + A<br />
40<br />
41 思路:<br />
42 第一次拿第一项的第一位F与DBCA,ECA,DE比较,这三个数除了第一位后面的每一项都没有F出现,<br />
43 所以把所有的F消除,取值F<br />
44 第二次拿第二项DBCA的第一位D与ECA,DE比较,这两数中除了第一位后边的每一项都没有D出现,<br />
45 所以就把所有的D消除,然后取值D<br />
46 第三次拿第二项BCA的B与ECA,E比较,这两个数中除了第一位后边的每一项都没有B出现,<br />
47 所以就把所有的B消除,取值B<br />
48 第四次拿第二项CA的C与ECA,E比较,ECA出现了C,所以不动CA,然后拿下一项的ECA的第一位E与最后一项的值E做比较,<br />
49 因为ECA的E重复了最后一项E,所以也不动ECA,然后拿最后一项的E与后边作比较,因为后边没项值,<br />
50 所以消除所有的E,取值E<br />
51 第四次拿返回开头拿第二项CA中的C与后边的项CA做比较,因为后边项中除了第一位,其他位没有C,<br />
52 所以消除所有的C,取值C<br />
53 第五次拿第二项的A与后边的项A做比较,因为后边项值有A,所有拿后边项A与后边项做比较,因为后边项没有值,<br />
54 所以消除所有的A,取值A<br />
55 结果<br />
56 FDBECA<br />
57<br />
58<br />
59 求H的MRO<br />
60 设求MRO的算法是L<br />
61 解析步骤:<br />
62                                     拆分                          合并<br />
63 L(H) = H + L(G) + L(F) + GF #H + GQPFDBECANMX + FDBECA + GF = HGQPFDBECANMX<br />
64 L(G) = G + L(Q) + L(F) + QF #G + QPECANMX + FDBECA + QF = GQPFDBECANMX<br />
65 L(Q) = Q + L(P) + L(N) + L(X) + PNX #Q + PECA + NM + X + PNX = QPECANMX<br />
66 L(X) = X    #X<br />
67 L(P) = P + L(E) + L(A) + EA #P + ECA + A + EA = PECA<br />
68 L(N) = N + L(M) + M     #N + M + M = NM<br />
69 L(M) = M    #M<br />
70 L(F) = F + L(D) + L(E) + DE #F + DBCA + ECA + DE = FDBECA<br />
71 L(E) = E + L(C) + L(A) + CA #E + CA + A + CA = ECA<br />
72 L(D) = D + L(B) + L(C) + BC #D + BA + CA + BC = DBCA<br />
73 L(C) = C + L(A) + A     #C + A + A = CA<br />
74 L(B) = B + L(A) + A     #B + A + A = BA<br />
75 L(A) = A    #A<br />
76 所以结果是<br />
77 HGQPFDBECANMX<br />
78<br />
79 和电脑运算的结果一致<br />
80 print(H.__mro__)</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>super() 找MRO顺序的下一个</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums"> 1 class Base1:<br />
 2     def chi(self):<br />
 3         print("我是Base1")<br />
 4<br />
 5 class Base2:<br />
 6     def chi(self):<br />
 7         print("我是Base2")<br />
 8<br />
 9 class Base3:<br />
10     def chi(self):<br />
11         print("我是Base3")<br />
12<br />
13 class Bar(Base1, Base2, Base3):<br />
14     def chi(self):<br />
15         print("我是Bar里面的chi1")<br />
16         # super(类名, self)  从某个类开始找下一个MRO<br />
17         super(Base2, self).chi()    # 此时调用的super. 在Bar调用 -&gt; super表示找MRO里的下一个<br />
18         # super().chi() # super(Bar, self).chi()<br />
19         print("我是Bar里面的chi2")<br />
20<br />
21 b = Bar()   # Bar, Base1, Base2, Base3, object<br />
22 b.chi()<br />
23 print(Bar.__mro__)<br />
24<br />
25 结果:<br />
26 我是Bar里面的chi1<br />
27 我是Base3<br />
28 我是Bar里面的chi2<br />
29 (&lt;class '__main__.Bar'&gt;, &lt;class '__main__.Base1'&gt;, &lt;class '__main__.Base2'&gt;, &lt;class '__main__.Base3'&gt;, &lt;class 'object'&gt;)<br />
30<br />
31<br />
32 事例2<br />
33 class Base1:<br />
34     def chi(self):<br />
35         super().chi()<br />
36         print("我是Base1")<br />
37<br />
38 class Base2:<br />
39     def chi(self):<br />
40         super().chi()<br />
41         print("我是Base2")<br />
42<br />
43 class Base3:<br />
44     def chi(self):<br />
45         print("我是Base3")<br />
46<br />
47 class Bar(Base1, Base2, Base3):<br />
48     def chi(self):<br />
49         print("我是Bar里面的吃1")<br />
50         super(Bar, self).chi()<br />
51         print("我是Bar里面的吃2")<br />
52<br />
53 b = Bar()<br />
54 b.chi()<br />
55<br />
56 结果<br />
57 我是Bar里面的吃1<br />
58 我是Base3<br />
59 我是Base2<br />
60 我是Base1<br />
61 我是Bar里面的吃2</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>MRO + super 面试题</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums"> 1 class Init(object):<br />
 2     def __init__(self, v):<br />
 3         print("init")<br />
 4         self.val = v<br />
 5<br />
 6 class Add2(Init):<br />
 7     def __init__(self, val):<br />
 8         print("Add2")<br />
 9         super(Add2, self).__init__(val)<br />
10         print(self.val)<br />
11         self.val += 2<br />
12<br />
13 class Mult(Init):<br />
14     def __init__(self, val):<br />
15         print("Mult")<br />
16         super(Mult, self).__init__(val)<br />
17         self.val *= 5<br />
18<br />
19 class HaHa(Init):<br />
20     def __init__(self, val):<br />
21         print("哈哈")<br />
22         super(HaHa, self).__init__(val)<br />
23         self.val /= 5<br />
24<br />
25 class Pro(Add2,Mult,HaHa):<br />
26     pass<br />
27<br />
28 class Incr(Pro):    # incr-&gt;pro-&gt;add2-&gt;Mult-&gt;HaHa-&gt;init<br />
29     def __init__(self, val):<br />
30         super(Incr, self).__init__(val)<br />
31         self.val += 1<br />
32 p = Incr(5)<br />
33 print(p.val)</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r8m16r8k.html">&period;net 预防用户复制页面地址直接进入</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxk2jd8.html">Mac下配置Apache &plus; Php &plus; Mysql环境</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1kjm49.html">&lbrack;Sass&rsqb;扩展&sol;继承</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o23p19.html">mysql 将列值转变为列的方法&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd0j2k8.html">navigationController pushViewController 多次跳转后怎么返回</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmvzde9.html">MySQL中的WITH ROLLUP</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1znrv59.html">C&plus;&plus; -windows与unix路径分隔符</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1gjk39.html">javascript widget ui mvc</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xe13e8.html">Windows Native API</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzzmz48.html">MIT 操作系统实验 MIT JOS lab2</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpd4oxq.html">PHP那些最好的轮子</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kn4v09.html">byte&lbrack;&rsqb;  Base64 Stream 之间相互转换</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y10mr8.html">Uva - 506 - System Dependencies</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jzx0l8.html">显著性检测&lpar;saliency detection&rpar;评价指标之sAUC（shuffled AUC）的Matlab代码实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/960jnd39.html">AS添加依赖报错Unable to merge dex</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjezde9.html">Django框架的探索</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rlj2z8.html">将map中的值赋值给一个java对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2rm3x9.html">Xshell设置密钥登录CentOS6&period;5&lowbar;64位（图文版）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv26og19.html">shape 图形</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kw433q.html">MaximumClique HDU1530</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8kjr7n39.html">so静态分析进阶练习&mdash;&mdash;一个CreakeMe的分析思路</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1d3dw9.html">11&period;webview、shareSDK</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllp6lxq.html">java web 乱码终结</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv23x3x9.html">Python又把GUI界面攻下了，今天就告诉你怎么玩</a>
			</li>
						<li><a href="https://www.batexi.com/a/960z1449.html">setting-mirrorO以及下载jar包流程简介</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25y7d3q.html">&lbrack;EXP&rsqb;Microsoft Windows 10 - XmlDocument Insecure Sharing Privilege Escalation</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllpz41q.html">python国外博客推荐</a>
			</li>
						<li><a href="https://www.batexi.com/a/93w6o70q.html">Mysql插入中文的字段内容时乱码的解决方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1xjy09.html">mysql 开发进阶篇系列 28 数据库二进制包安装&lpar;centos系统准备&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwvzdn38.html">Java NIO中的通道Channel（一）通道基础</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
